Public Class frmMain
    Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

    Public Sub New()
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen

    End Sub

    ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
    Friend WithEvents ListBox1 As System.Windows.Forms.ListBox
    Friend WithEvents Button1 As System.Windows.Forms.Button
    Friend WithEvents Button2 As System.Windows.Forms.Button
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Button3 As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
Me.ListBox1 = New System.Windows.Forms.ListBox()
Me.Button1 = New System.Windows.Forms.Button()
Me.Button2 = New System.Windows.Forms.Button()
Me.Label1 = New System.Windows.Forms.Label()
Me.Button3 = New System.Windows.Forms.Button()
Me.SuspendLayout()
'
'ListBox1
'
Me.ListBox1.Location = New System.Drawing.Point(16, 16)
Me.ListBox1.Name = "ListBox1"
Me.ListBox1.Size = New System.Drawing.Size(144, 212)
Me.ListBox1.TabIndex = 0
'
'Button1
'
Me.Button1.Location = New System.Drawing.Point(176, 24)
Me.Button1.Name = "Button1"
Me.Button1.Size = New System.Drawing.Size(112, 23)
Me.Button1.TabIndex = 1
Me.Button1.Text = "Liste fllen"
'
'Button2
'
Me.Button2.Enabled = False
Me.Button2.Location = New System.Drawing.Point(176, 48)
Me.Button2.Name = "Button2"
Me.Button2.Size = New System.Drawing.Size(112, 23)
Me.Button2.TabIndex = 2
Me.Button2.Text = "Doppelte entfernen"
'
'Label1
'
Me.Label1.Location = New System.Drawing.Point(176, 80)
Me.Label1.Name = "Label1"
Me.Label1.TabIndex = 3
Me.Label1.Text = "Eintrge: 0"
'
'Button3
'
Me.Button3.Location = New System.Drawing.Point(184, 208)
Me.Button3.Name = "Button3"
Me.Button3.TabIndex = 4
Me.Button3.Text = "Ende"
'
'frmMain
'
Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
Me.ClientSize = New System.Drawing.Size(292, 266)
Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.Button3, Me.Label1, Me.Button2, Me.Button1, Me.ListBox1})
Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
Me.MaximizeBox = False
Me.MinimizeBox = False
Me.Name = "frmMain"
Me.Text = "Doppelte Eintrge entfernen"
Me.ResumeLayout(False)

    End Sub

#End Region

    ' Liste fllen
    Private Sub Button1_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles Button1.Click

        Dim i As Integer

        ' Listbox leeren
        ListBox1.Items.Clear()

        ' Zufallsgenerator anwerfen...
        Randomize()

        For i = 0 To Int(Rnd() * 3000)
            '... mit Zufallszahlen fllen
            ListBox1.Items.Add(Int(Rnd() * 500))
        Next

        Label1.Text = "Eintrge: " & ListBox1.Items.Count
        Button2.Enabled = True
    End Sub

    'Liste leeren
    Private Sub Button2_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles Button2.Click

        RemoveDoubleEntries(ListBox1)

        Label1.Text = "Eintrge: " & ListBox1.Items.Count
        Button2.Enabled = True
    End Sub

    Private Sub RemoveDoubleEntries(ByVal LBox As ListBox)
        Dim Entries1() As String
        Dim Entries2() As String
        Dim UB As Integer
        Dim i1 As Integer
        Dim i2 As Integer
        Dim found As Boolean
        Dim DidInit As Boolean

        ' Array(Datenfeld) auf die erforderliche Gre setzen
        ReDim Entries1(LBox.Items.Count)

        ' Liste einlesen
        For i1 = 0 To LBox.Items.Count - 1
            Entries1(i1) = LBox.Items.Item(i1)
        Next

        ' Alle Eintrge durchgehen
        For i1 = 0 To UBound(Entries1)
            'Flag setzen
            found = False

            ' Alle bereits in die neue Liste eingefgten Eintrge durchgehen
            For i2 = 0 To UB
                ' Schon Initialisiert?
                If Not DidInit Then
                    'Wenn nicht, erst Initialisieren (spter)

                    found = False
                    Exit For
                ElseIf Entries1(i1) = Entries2(i2) Then
                    'Eintrag in Liste gefunden
                    found = True
                    Exit For
                End If
            Next

            'Wurde Eintrag in Liste gefunden?
            If Not found Then
                'Wurde bereits Initialisierung durchgefhrt?
                If Not DidInit Then
                    'Neue Liste auf erforderliche Gre setzen
                    ReDim Entries2(UBound(Entries1))
                    DidInit = True
                End If

                'In neue Liste einfgen
                Entries2(UB) = Entries1(i1)

                ' Zhler hochsetzen. Enthlt die Nummer des letzten Eintrags 
                '  der neuen Liste.
                UB = UB + 1
            End If
        Next

        'Einmal zuviel erhht
        UB = UB - 1

        ' Die restlichen Elemente abschneiden
        ReDim Preserve Entries2(UB)

        'Liste leeren und mit neuer Liste neu fllen
        LBox.Items.Clear()
        For i1 = 0 To UB
            LBox.Items.Add(Entries2(i1))
        Next
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles Button3.Click

        Me.Close()
    End Sub
End Class
